Subject: Re: it appears that this whole "ask for AAAA before A" will be painful

From: Peter Koch <[email-masked]>
Date: Mon, 09 Dec 2002 00:00:26 +0100

> -------- to show you that it's not AAAA prejudice, let's look for an RT RR:

Funny enough, try asking for "ANY" ...

> SERVFAIL is the wrong answer.  SERVFAIL is an indication, not that the type
> isn't known, but that the zone is invalid at that server.  recursive servers
> are within their rights to cache SERVFAIL at <ZONE,CLASS>, rather than at
> <NAME,CLASS,TYPE>.  the proper answer to a AAAA or RT question, if there are

And how do they know which zone it is that fails? www.United.COM may be in
a seperate zone below United.COM, so if you receive a SERVFAIL for queries
for www.United.COM you probably can't be sure what to cache anyway. In
addition, not even RFC 2308 defines this type of caching.

> no RR's of that type at that name, is NOERROR/ANCOUNT=0.

One might argue that NOTIMP would also be fine, at least until the "unknown
types" draft goes live. The "ANY" result would remain strange, though.

-Peter

--
to unsubscribe send a message to [email-masked] with
the word 'unsubscribe' in a single line as the message text body.
archive: <http://ops.ietf.org/lists/namedroppers/>

---

From: "D. J. Bernstein" <[email-masked]>
Date: 8 Dec 2002 23:30:43 -0000

Paul Vixie writes:
> let web sites like united.com be stranded in the new IPv6 era?

Wow. Do you think that IPv6 is some sort of unstoppable force that will
beat united.com into submission? Has it ever occurred to you that users
care a hell of a lot more about united.com than about IPv6? For further
comments, see http://cr.yp.to/djbdns/ipv6mess.html.

> SERVFAIL is an indication, not that the type isn't known, but that the
> zone is invalid at that server.

That's a wild oversimplification. SERVFAIL can indicate all sorts of
other problems.

> recursive servers are within their rights to cache SERVFAIL at <ZONE,CLASS>

That's absurd.

Similarly, it's silly for a client to abandon A records merely because
the AAAA-IPv6 connection attempt has failed. The A records are valid
whether or not AAAA records exist.

Obviously trying A first is better right now, although one can imagine a
future world where trying AAAA first is better.

None of this would ever have been an issue if people had used 16-byte A
records instead of inventing a completely unnecessary AAAA type.

---D. J. Bernstein, Associate Professor, Department of Mathematics,
Statistics, and Computer Science, University of Illinois at Chicago

---

From: Michael Richardson <[email-masked]>
Date: Sun, 08 Dec 2002 20:58:58 -0500

>>>>> "Paul" == Paul Vixie <[email-masked]> writes:
    Paul> SERVFAIL is the wrong answer.  SERVFAIL is an indication, not that the type
    Paul> isn't known, but that the zone is invalid at that server.  recursive servers
    Paul> are within their rights to cache SERVFAIL at <ZONE,CLASS>, rather than at
    Paul> <NAME,CLASS,TYPE>.  the proper answer to a AAAA or RT question, if there are
    Paul> no RR's of that type at that name, is NOERROR/ANCOUNT=0.

  Indeed.

    Paul> do we need a BCP draft recommending that SERVFAIL be ignored, in case it came
    Paul> from a load balancer?  or shall we call the load balancers faulty, and let
    Paul> web sites like united.com be stranded in the new IPv6 era?

  I expect that the first part was rhetorical? How could we tell if it was a
load balancer?

  This is something that places like rfc-ignorant.org should document.

]       ON HUMILITY: to err is human. To moo, bovine.           |  firewalls  [
]   Michael Richardson, Sandelman Software Works, Ottawa, ON    |net architect[
] [email-masked] http://www.sandelman.ottawa.on.ca/ |device driver[
] panic("Just another Debian GNU/Linux using, kernel hacking, security guy"); [

---

From: Bill Manning <[email-masked]>
Date: Sun, 8 Dec 2002 20:25:36 -0800 (PST)

% do we need a BCP draft recommending that SERVFAIL be ignored, in case it came
% from a load balancer?  or shall we call the load balancers faulty, and let
% web sites like united.com be stranded in the new IPv6 era?
% 

	the distinction here is that IPv4 and IPv6 are different protocols,
	much like SNA and DECnet are different.  local optimizations
	e.g. load balancers designed for a subset of DNS capability under
	IPv4, should be recongnised as such when considering larger, 
	global usefulness.   
	
	while united.com may be a poor example, most sites (that will still
	be around) will adjust to adopt new techniques/technologies that 
	are able to bring value, be that IPv6, DNSSEC, IDN or any other 
	new feature that the DNS is asked to accomodate.

	my 0.02, don't accomodate such cruft. no bcp recommending SERVFAIL
	better would be a bcp pointing out the problems with minimialist,
	local optimizations.

--bill

Opinions expressed may not even be mine by the time you read them, and
certainly don't reflect those of any other entity (legal or otherwise).